#include <stdio.h>
#include "arsclib.h"
#include "genfui.h"
#include "valparse.h"

extern VALUE *falseValue;
extern VALUE *trueValue;

static VALUE *xmldb;
static VALUE *xml2db;
static int level;
static VALUE *selection;
static VALUE *doc_selection;

void initgenfui()
{
   xmldb         = falseValue;
   xml2db        = falseValue;
   level         = 0; 
   selection     = falseValue;
   doc_selection = falseValue;
}

void menu_proc(VALUE *menu)
{
   VALUE *input;
   VALUE *fn_name;
   VALUE *args;
   VALUE *fn;
   VALUE *menu_item;
   
   input = get_fn(menu);
   fn_name = car(input);
   args = cdr(input);
   fn = NULL;
   menu_item = NULL; 
   if (fn_name->val.sym == defName("help")) {
      display_menu(menu);
      menu_proc(menu);
   }
   else if (fn_name->val.sym == defName("quit")) {
      level = level - 1;
      return;
   }
   else {
      menu_item = assoc(fn_name,menu);
      fn = nth(3, menu_item);
      if (equal(nth(4, menu_item), newSYMV(defName("f")))) {
         if (in_domainp(newVLIST(args), menu_item) == falseValue) {
            printf("argument check failed: ");
	    prValue(args);
	 }
	 else {
	    prValue(apply(fn, newVLIST(args)));
         }
	 menu_proc(menu);
      }
      else if (equal(nth(4, menu_item), newSYMV(defName("m")))) {
         level = level +1;
	 display_menu(nth(5,menu_item));
         menu_proc(nth(5, menu_item));
	 display_menu(menu);
         menu_proc(menu);
      }
      else {
         printf("invalid type for menu-item: ");
         prValue(nth(4,menu_item));
      }
   }
}                      
             
static int level; 

VALUE * in_domainp(VLIST *args, VALUE *menu_item)
{
   if (lengthVL(args) == nth(5,menu_item)->val.ival) {
      return apply(nth(6,menu_item), args);
   }
   else {
      return falseValue;
   }
}
             
static VALUE * abkp(VALUE *line, VALUE *menu)
{
   if (menu == NULL) {
      return falseValue;
   }
   else {
      if ((cadr(car(menu)) != falseValue) &&
          equal(line, cadr(car(menu)))) {
         return caar(menu);
      }
      else {
         return abkp(line,cdr(menu));
      }
   }
}

VALUE *get_fn(VALUE *menu)
{
   VALUE *line;
   VALUE *abk;
   VALUE *fn_name;

   while(1) {
      printf("%d>>",level);
      line = readWithoutPrompt();
      if (atomp(line)) {
         if (line->type == SYMV) {
            if (line->val.sym == defName("q")) {
               return cons(newSYMV(defName("quit")),NULL);
	    }
	    else if (line->val.sym == defName("h")) {
               return cons(newSYMV(defName("help")),NULL);
	    }
	    else {
	       abk = abkp(line,menu);
               if (abk != falseValue) {
	          return cons(abk,NULL);
	       }
	       else {
	          return cons(newSYMV(defName("help")),NULL);
	       }
	    }
         }
         else {
            return cons(newSYMV(defName("help")),NULL);
         }
      }
      else {
	 fn_name = car(line);
	 if ((equal(fn_name,newSYMV(defName("help")))) ||
             (equal(fn_name,newSYMV(defName("quit"))))) {
            return line;
         }
         else {
            if (assoc(fn_name,menu) == falseValue) {
	       printf("invalid input!\n");
            }
            else {
	       return line;
            }
         }
      }
   }
}
             
//VALUE *lf_display_menu_aux(ENV *env);

VALUE *lf_display_menu_aux(ENV *env)
{
   VALUE *x;
   VALUE *abk;

   x = getVar(defName("x"),env);
   abk = cadr(x);
   if (equal(nth(4,x), newSYMV(defName("m")))) {
      if (abk == falseValue) {
         return list2(car(x),newSTRV(defName("-->")));
      }
      else {
         return list3(car(x),
		      cons(cadr(x),NULL),
		      newSTRV(defName("-->")));
      }
   }
   else {
      if (abk == falseValue) {
         return list3(car(x),
		      cons(NULL,NULL),
		      nth(5,x));
      }
      else {
         return list3(car(x),cons(cadr(x),NULL),nth(5,x));
      }
   }
}

void display_menu(VALUE *menu)
{
   VALUE *proc;

   proc = newCLAMV(ncons(defName("x"),NULL),
		   lf_display_menu_aux,
		   emptyEnv());
   prVal(map(proc,menu));
   printf("\n");
}

