/***********************************************************************
                          main.c  -  description
                          ----------------------
    begin                : Mit Apr 17 22:22:30 CEST 2001
    copyright            : (C) 2001-2004 by Georg P. Loczewski
    email                : gpl@lambda-bound.de
 **********************************************************************/

/***********************************************************************
*                                                                      *
* This program is free software; you can redistribute it and/or modify *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation; either version 2 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
***********************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>

#include <setjmp.h>
#include <malloc.h>
#include "gc.h"
#include <string.h>
#include "valparse.h"
#include "genfui.h"


extern int true;
extern VALUE *falseValue;
extern VALUE *trueValue;
extern VALUE *nil;

jmp_buf _EXH;

static VALUE *db_create;
static VALUE *db_open;
static VALUE *db_save;
static VALUE *db_select;
static VALUE *db_display;
static VALUE *db_import;
static VALUE *db_export;
static VALUE *xml_select;
static VALUE *xml_display;
static VALUE *xml_export;
static VALUE *xml_import;
static VALUE *xml_delete;
static VALUE *xml_update;

static VALUE *lf_db_create(ENV *env)
{
   printf("db_create executed!\n");
   return nil;
}

static VALUE *lf_db_open(ENV *env)
{
   printf("db_open executed!\n");
   return nil;
}

static VALUE *lf_db_save(ENV *env)
{
   printf("db_save executed!\n");
   return nil;
}

static VALUE *lf_db_select(ENV *env)
{
   printf("db_select executed!\n");
   return nil;
}

static VALUE *lf_db_display(ENV *env)
{
   printf("db_display executed!\n");
   return nil;
}

static VALUE *lf_db_import(ENV *env)
{
   printf("db_import executed!\n");
   return nil;
}

static VALUE *lf_db_export(ENV *env)
{
   printf("db_export executed!\n");
   return nil;
}

static VALUE *lf_xml_select(ENV *env)
{
   printf("xml_select executed!\n");
   return nil;
}

static VALUE *lf_xml_display(ENV *env)
{
   printf("xml_display executed!\n");
   return nil;
}

static VALUE *lf_xml_export(ENV *env)
{
   printf("xml_export executed!\n");
   return nil;
}

static VALUE *lf_xml_import(ENV *env)
{
   printf("xml_import executed!\n");
   return nil;
}

static VALUE *lf_xml_delete(ENV *env)
{
   printf("xml_delete executed!\n");
   return nil;
}

static VALUE *lf_xml_update(ENV *env)
{
   printf("xml_update executed!\n");
   return nil;
}


static void claminit(ENV *penv)
{
   db_create    = newCLAMV(ncons(defName("name"),NULL),
		           lf_db_create,
			   penv);
   db_open      = newCLAMV(ncons(defName("name"),NULL),
		           lf_db_open,
			   penv);
   db_save      = newCLAMV(NULL,
		           lf_db_save,
			   penv);
   db_select    = newCLAMV(ncons(defName("scope"),
			      ncons(defName("props"),NULL)),
		           lf_db_select,
			   penv);
   db_display   = newCLAMV(NULL,
		           lf_db_display,
			   penv);
   db_import    = newCLAMV(ncons(defName("file-name"),NULL),
		           lf_db_import,
			   penv);
   db_export    = newCLAMV(ncons(defName("file-name"),NULL),
		           lf_db_export,
			   penv);
   xml_select   = newCLAMV(ncons(defName("scope"),
			      ncons(defName("props"),NULL)),
		           lf_xml_select,
			   penv);
   xml_display  = newCLAMV(NULL,
		           lf_xml_display,
			   penv);
   xml_export   = newCLAMV(ncons(defName("file-name"),NULL),
		           lf_xml_export,
			   penv);
   xml_import   = newCLAMV(ncons(defName("file-name"),NULL),
		           lf_xml_import,
			   penv);
   xml_delete   = newCLAMV(NULL,
		           lf_xml_delete,
			   penv);
   xml_update   = newCLAMV(NULL,
		           lf_xml_update,
			   penv);
}

static VALUE *arg_check_dummy(ENV *env)
{
   return trueValue;
}

static VALUE *make_top_level(ENV *penv)
{
   return
	   list3(
                 list5( 
		   newSYMV(defName("Database")),
		   newSYMV(defName("d")),
                   falseValue,
		   newSYMV(defName("m")),
                   list3(
                     list6( 
			   newSYMV(defName("new")),
                           falseValue,
			   db_create ,
			   newSYMV(defName("f")),
			   newINTV(1) ,
                           newCLAMV(ncons(defName("name"),NULL),
				    arg_check_dummy,
				    penv)),
                     list6( 
			   newSYMV(defName("open")),
                           falseValue,
			   db_open ,
			   newSYMV(defName("f")),
			   newINTV(1) ,
                           newCLAMV(ncons(defName("name"),NULL),
				    arg_check_dummy,
				    penv)),
                     list6( 
			   newSYMV(defName("save")),
			   newSYMV(defName("s")),
			   db_save ,
			   newSYMV(defName("f")),
			   newINTV(0) ,
                           newCLAMV(NULL,
				    arg_check_dummy,
				    penv)))),
                 list5( 
		   newSYMV(defName("XML-Document")),
		   newSYMV(defName("x")),
                   falseValue,
		   newSYMV(defName("m")),
                   list6(
                     list6( 
			   newSYMV(defName("import")),
                           falseValue,
			   xml_import ,
			   newSYMV(defName("f")),
			   newINTV(1) ,
                           newCLAMV(ncons(defName("name"),NULL),
				    arg_check_dummy,
				    penv)),
                     list6(
			   newSYMV(defName("doc-select")),
                           falseValue,
			   xml_select ,
			   newSYMV(defName("f")),
			   newINTV(2) ,
                           newCLAMV(ncons(defName("scope"),
				       ncons(defName("props"),NULL)),
				    arg_check_dummy,
				    penv)),
                     list6(
			   newSYMV(defName("display")),
			   newSYMV(defName("p")),
			   xml_display ,
			   newSYMV(defName("f")),
			   newINTV(0) ,
                           newCLAMV(NULL,
				    arg_check_dummy,
				    penv)),
                     list6(
			   newSYMV(defName("delete")),
			   newSYMV(defName("d")),
			   xml_delete,
			   newSYMV(defName("f")),
			   newINTV(0), 
                           newCLAMV(NULL,
				    arg_check_dummy,
				    penv)),
                     list6(
			   newSYMV(defName("update")),
			   newSYMV(defName("u")),
			   xml_update ,
			   newSYMV(defName("f")),
			   newINTV(0),
                           newCLAMV(NULL,
				    arg_check_dummy,
				    penv)),
                     list6(
			   newSYMV(defName("export")),
                           falseValue,
			   xml_export ,
			   newSYMV(defName("f")),
			   newINTV(1),
                           newCLAMV(ncons(defName("name"),NULL),
				    arg_check_dummy,
				    penv)))),
                 list5( 
		   newSYMV(defName("Node")),
		   newSYMV(defName("n")),
                   falseValue,
		   newSYMV(defName("m")),
                   list3(
                     list6(
			   newSYMV(defName("select")),
                           falseValue,
			   db_select ,
			   newSYMV(defName("f")),
			   newINTV(2),
                           newCLAMV(ncons(defName("scope"),
				       ncons(defName("props"),NULL)),
				    arg_check_dummy,
				    penv)),
                     list6(
			   newSYMV(defName("display")),
			   newSYMV(defName("p")),
			   db_display ,
			   newSYMV(defName("f")),
			   newINTV(0),
                           newCLAMV(NULL,
				    arg_check_dummy,
				    penv)),
                     list6(
			   newSYMV(defName("export")),
                           falseValue,
			   db_export ,
			   newSYMV(defName("f")),
			   newINTV(1),
                           newCLAMV(ncons(defName("name"),NULL),
				    arg_check_dummy,
				    penv)))));
}

int
main (int argc, char *argv[])
{
  int ret;
  VALUE *topl;
  ENV *penv;

  initNames ();
  penv = emptyEnv();
  valparsinit(NULL);
  claminit(penv);
  printf(
     "*** Structured Information Storage and Retrieval System ***\n");
  topl = make_top_level(penv);
  prValue(topl);
  display_menu(topl);
  //prValue(get_fn(topl));
  menu_proc(topl);
  return EXIT_SUCCESS;
}
